package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;
import java.awt.Rectangle;
import java.awt.Dimension;
/**
  * GUI-Klassen til  Aktivitetadministration
  * @version  Februar 2003 (1.15)
  * @author   ObjectGenerator
*/

public  class AktivitetAdmDialog extends Dialog
{
  private Frame        ownerFrame;

  private Projekt      projekt;
  private Aktivitet    aktivitet;

  private Button       knapSelect  = new Button     ();
  private Button       knapReplace = new Button     ();
  private Button       knapFaerdigmeld = new Button     ();
  private Button       knapAdd     = new Button     ();
  private Button       knapRemove  = new Button     ();
  private Button       knapTimeforbrug  = new Button     ();
  private Button       knapOpretTimeforbrug  = new Button     ();
  private Button       knapReturn  = new Button     ();

  private Label         labelProjektBetegnelse      = new Label ();
  private TextField     projektBetegnelse           = new TextField ();
  private Label         labelMedarbejderNavn        = new Label ();
  private TextField     medarbejderNavn             = new TextField ();
  private Label         labelBetegnelse      = new Label ();
  private TextField     betegnelse           = new TextField ();
  private Label         labelTildeltDato     = new Label ();
  private TextField     tildeltDato          = new TextField ();
  private Label         labelFaerdigDato     = new Label ();
  private TextField     faerdigDato          = new TextField ();
  private Label         labelTilstand        = new Label ();
  private TextField     tilstand             = new TextField ();


  public AktivitetAdmDialog (Frame ownerFrame, Projekt projekt, Aktivitet aktivitet)
  {
    super(ownerFrame, true/*modal*/);
    this.ownerFrame = ownerFrame;
    this.projekt = projekt;
    this.aktivitet = aktivitet;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {

    this.setSize(new Dimension(530, 334));
    this.setTitle("Aktivitet");


    this.setLayout(null);
  
    knapSelect.setLabel("Vlg aktivitet");
    knapSelect.setBounds(new Rectangle(375, 40, 140, 25));
    knapAdd.setLabel("Opret aktivitet");
    knapAdd.setBounds(new Rectangle(375, 70, 140, 25));
    knapReplace.setLabel("Ret stamdata");
    knapReplace.setBounds(new Rectangle(375, 100, 140, 25));
    knapFaerdigmeld.setLabel("Frdigmeld aktivitet");
    knapFaerdigmeld.setBounds(new Rectangle(375, 130, 140, 25));
    knapRemove.setLabel("Slet aktivitet");
    knapRemove.setBounds(new Rectangle(375, 160, 140, 25));
    knapTimeforbrug.setLabel("Vis timeforbrug");
    knapTimeforbrug.setBounds(new Rectangle(375, 200, 140, 25));
    knapOpretTimeforbrug.setLabel("Registrer timeforbrug");
    knapOpretTimeforbrug.setBounds(new Rectangle(375, 230, 140, 25));
    knapReturn.setLabel("Retur");
    knapReturn.setBounds(new Rectangle(375, 270, 140, 25));

    labelProjektBetegnelse.setText("Projekt:");
    labelProjektBetegnelse.setBounds(new Rectangle(15, 45, 70, 15));
    labelMedarbejderNavn.setText("Medarbejder:");
    labelMedarbejderNavn.setBounds(new Rectangle(15, 115, 70, 15));
    labelBetegnelse.setText("Betegnelse:");
    labelBetegnelse.setBounds(new Rectangle(15, 95, 70, 15));
    labelTildeltDato.setText("Etableret dato :");
    labelTildeltDato.setBounds(new Rectangle(15, 145, 75, 15));
    labelFaerdigDato.setText("Frdig dato:");
    labelFaerdigDato.setBounds(new Rectangle(15, 170, 70, 15));
    labelTilstand.setText("Tilstand:");
    labelTilstand.setBounds(new Rectangle(15, 195, 65, 15));


    projektBetegnelse.setEnabled(false);
    projektBetegnelse.setBounds(new Rectangle(110, 45, 250, 20));
    medarbejderNavn.setEnabled(false);
    medarbejderNavn.setBounds(new Rectangle(110, 115, 250, 20));
    betegnelse.setEnabled(false);
    betegnelse.setBounds(new Rectangle(110, 90, 250, 20));
    tildeltDato.setEnabled(false);
    tildeltDato.setBounds(new Rectangle(110, 140, 75, 20));
    faerdigDato.setEnabled(false);
    faerdigDato.setBounds(new Rectangle(110, 165, 75, 20));
    tilstand.setEnabled(false);
    tilstand.setBounds(new Rectangle(110, 190, 75, 20));

    this.add(knapSelect);
    this.add(knapReplace);
    this.add(knapFaerdigmeld);
    this.add(knapAdd);
    this.add(knapRemove);
    this.add(knapTimeforbrug);
    this.add(knapOpretTimeforbrug);
    this.add(knapReturn);
    this.add(labelProjektBetegnelse, null);
    this.add(projektBetegnelse, null);
    this.add(labelMedarbejderNavn, null);
    this.add(medarbejderNavn, null);
    this.add(labelBetegnelse, null);
    this.add(betegnelse, null);
    this.add(labelTildeltDato, null);
    this.add(tildeltDato, null);
    this.add(labelFaerdigDato, null);
    this.add(faerdigDato, null);
    this.add(labelTilstand, null);
    this.add(tilstand, null);


    this.addWindowListener ( new AktivitetAdm_WindowClosing(this) );
    knapSelect.addActionListener(new AktivitetAdm_knapSelect_Action(this));
    knapReplace.addActionListener(new AktivitetAdm_knapReplace_Action(this));
    knapFaerdigmeld.addActionListener(new AktivitetAdm_knapFaerdigmeld_Action(this));
    knapAdd.addActionListener(new AktivitetAdm_knapAdd_Action(this));
    knapRemove.addActionListener(new AktivitetAdm_knapRemove_Action(this));
    knapTimeforbrug.addActionListener(new AktivitetAdm_knapTimeforbrug_Action(this));
    knapOpretTimeforbrug.addActionListener(new AktivitetAdm_knapOpretTimeforbrug_Action(this));
    knapReturn.addActionListener(new AktivitetAdm_knapReturn_Action(this));

    projektBetegnelse.setText(projekt.getBetegnelse());

    aktivitetToFrame ();
  }
  
  //=================================================================
  
  public void aktivitetToFrame ()
  {
    if (aktivitet==null)
    {
      this.medarbejderNavn.setText("");
      this.betegnelse.setText("");
      this.tildeltDato.setText("");
      this.faerdigDato.setText("");
      this.tilstand.setText("");
      knapReplace.setEnabled(false);
      knapRemove.setEnabled(false);
      knapFaerdigmeld.setEnabled(false);
      knapTimeforbrug.setEnabled(false);
      knapOpretTimeforbrug.setEnabled(false);
    }
    else
    {
      Medarbejder  medarbejder = aktivitet.getMedarbejder();
      this.medarbejderNavn.setText(medarbejder.getFornavn()+" "+
                                   medarbejder.getEfternavn());
      this.betegnelse.setText(""+aktivitet.getBetegnelse());
      if ( aktivitet.getTildeltDato() == null )
        this.tildeltDato.setText("");
      else
        this.tildeltDato.setText(aktivitet.getTildeltDato().toString().substring(0,19));
      if ( aktivitet.getFaerdigDato() == null )
        this.faerdigDato.setText("");
      else
        this.faerdigDato.setText(aktivitet.getFaerdigDato().toString().substring(0,19));
      if (aktivitet.getTilstand() == Aktivitet.TILSTAND_FAERDIG)   this.tilstand.setText("Frdig");
      else  this.tilstand.setText("Aktiv");
      knapReplace.setEnabled(true);
      if (aktivitet.getTilstand() == Aktivitet.TILSTAND_AKTIV)
      {
        knapFaerdigmeld.setEnabled(true);
        knapRemove.setEnabled(false);
        if (medarbejder.getTilstand() == Medarbejder.TILSTAND_ANSAT)
          knapOpretTimeforbrug.setEnabled(true);
        else  
          knapOpretTimeforbrug.setEnabled(false);
      }
      else if (aktivitet.getTilstand() == Aktivitet.TILSTAND_FAERDIG)
      {
        knapFaerdigmeld.setEnabled(false);
        knapRemove.setEnabled(true);
        knapOpretTimeforbrug.setEnabled(false);
      }
    }
  }
  
  public void selectAktivitet ()
  {
    Iterator  iterator = projekt.getAktivitetIterator();
    SelectDialog  selectDialog = new SelectDialog(this.ownerFrame,"Aktiviteter",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);
    Object[]  ov  =  selectDialog.getSelectedObjects();
    if ((ov!=null)&&(ov.length>0))
      aktivitet = (Aktivitet)ov[0];
    aktivitetToFrame ();
  }
  
  public void replaceAktivitet ()
  {

    AktivitetRetStamdataDialog  aktivitetRetStamdataDialog = new AktivitetRetStamdataDialog(this.ownerFrame, this.aktivitet);
    aktivitetRetStamdataDialog.setVisible(true);

    aktivitetToFrame ();
  }
  
  public void faerdigmeldAktivitet ()
  {

    AktivitetFaerdigDialog  aktivitetFaerdigDialog = new AktivitetFaerdigDialog(this.ownerFrame, this.aktivitet);
    aktivitetFaerdigDialog.setVisible(true);

    aktivitetToFrame ();
  }

  public void addAktivitet ()
  {

    AktivitetOpretDialog  aktivitetOpretDialog = new AktivitetOpretDialog(this.ownerFrame, projekt);
    aktivitetOpretDialog.setVisible(true);
    aktivitet = aktivitetOpretDialog.getAktivitet();

    aktivitetToFrame ();
  }
  
  public void visTimeforbrug ()
  {
    Iterator  iterator = aktivitet.getTimeforbrugIterator();
    SelectDialog  selectDialog = new SelectDialog(this.ownerFrame,"Timeforbrug",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);
  }

  public void addTimeforbrug ()
  {
    TimeforbrugOpretDialog  timeforbrugOpretDialog = new TimeforbrugOpretDialog(this.ownerFrame, aktivitet);
    timeforbrugOpretDialog.setVisible(true);
  }


  public void removeAktivitet ()
  {
    // IKKE IMPLEMENTERET
  }

  public void closeWindow ()
  {
    this.dispose();
  }
}

//=================================================================

class AktivitetAdm_WindowClosing extends WindowAdapter
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_WindowClosing(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}

class AktivitetAdm_knapSelect_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapSelect_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.selectAktivitet();  }
}

class AktivitetAdm_knapReplace_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapReplace_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.replaceAktivitet();  }
}

class AktivitetAdm_knapFaerdigmeld_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapFaerdigmeld_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.faerdigmeldAktivitet();  }
}

class AktivitetAdm_knapAdd_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapAdd_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addAktivitet();  }
}

class AktivitetAdm_knapRemove_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapRemove_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.removeAktivitet();  }
}

class AktivitetAdm_knapTimeforbrug_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapTimeforbrug_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.visTimeforbrug();  }
}
class AktivitetAdm_knapOpretTimeforbrug_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapOpretTimeforbrug_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addTimeforbrug();  }
}

class AktivitetAdm_knapReturn_Action implements java.awt.event.ActionListener
{
  AktivitetAdmDialog   adaptee;
  AktivitetAdm_knapReturn_Action(AktivitetAdmDialog  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}

