package projektsystemKerne;
import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
  * Klassen til hndtering af Postdistrikt-Objekter i relationel database  
  * @version  Januar 2002 (1.10)
  * @author   DBObjectAdministratorGenerator  
*/  

public class PostdistriktAdministrator  extends DBObjectAdministrator  
{  
  public  PostdistriktAdministrator (DBAdministrator    dbAdministrator,
                              String table)  
  {  
    super (dbAdministrator, table, "Postnr","SELECT * FROM "+table);  
  }

  // get-metode med to ngler disables, da objekt er med enkeltngle
  public  Object  get (int key, int key2)
  {
    System.out.println("Fejl: der skal anvendes metode med eet nglerfelt");
    throw new UnsupportedOperationException();
  }

  // contains-metode som checkker om objekt med ngle findes
  public  boolean  contains ( Object object )  
  {  
    Postdistrikt   postdistrikt = (Postdistrikt)object;  
    return get(postdistrikt.getPostnr()) != null;
  }

  // opretter et nyt object p databasen - implementer abstract  
  public  boolean  add ( Object object )  
  {  
    Postdistrikt   postdistrikt = (Postdistrikt)object;  
    String sql   = "INSERT INTO "+table  
                + " ("  
                + "  [Postnr]"  
                + "  ,[Distrikt]"  
                + " ) VALUES "  
                + " ("  
                + "  "  +postdistrikt.getPostnr()      +""  
                + ", '"  +postdistrikt.getDistrikt()      +"'"  
                + " )";  
    return ( executeUpdate (sql) );  
  }  

  // opdaterer et eksisterede object p databasen - implementer abstract  
  public  boolean  replace ( Object object )  
  {  
    Postdistrikt   postdistrikt = (Postdistrikt)object;  
    String sql  = "UPDATE "+table+" SET"  
                + "  [Distrikt]='"  +postdistrikt.getDistrikt()    +"'"  
                + " WHERE [Postnr]="  +postdistrikt.getPostnr()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // sletter et object fra dabasen - implementer abstract  
  public  boolean  remove ( Object object )  
  {  
    Postdistrikt   postdistrikt = (Postdistrikt)object;  
    String sql  = "DELETE * FROM "+table  
                + " WHERE [Postnr]="  +postdistrikt.getPostnr()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // Konverter fra ResultSet til object - implementer abstract  
  protected  Object  convertToObject (ResultSet resultSet)  
  {  
    try  
    {  
      Postdistrikt   postdistrikt = new Postdistrikt (   resultSet.getInt("Postnr"),  
                                   resultSet.getString("Distrikt")   ); 
      return (postdistrikt);  
    }  
    catch (SQLException e)      
    {  
      System.out.println("Fejl ved convertToObject fra "+table);
      return (null);  
    }  
  }  

  // returner et nyt object - skal gemmes p databasen med add
  public  Postdistrikt  newPostdistrikt (int postnr, String distrikt )
  {
    Postdistrikt postdistrikt = new Postdistrikt ( postnr, distrikt );
    return (postdistrikt);
  }

}  
