package projektsystemFunktioner;
import projektsystemKerne.*;
import java.util.*;
/**  
  * Funktionsklasse med overordnede funktioner
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/  
public class MedarbejderFunktioner
{
  //-------------------------------------------------------------------
  //  Det kunne have vre en god id at have en iterator der bare, 
  //  kunne give alle projekter med en bestemt tilstand.
  //  En sdan vil dog med fordel kunne placeres i kernen p GlobalModel,
  //  hvor der kan optimeres en del f.eks med SQL i DB-lsningen.
  //-------------------------------------------------------------------
  public static Iterator ansatteMedarbejdereIterator()
  {
    Iterator  alleIterator = GlobalModel.getProjektsystem().getMedarbejderIterator();
    Vector vectorAnsatte = new Vector();
    while (alleIterator.hasNext())
    {
      Medarbejder medarb = (Medarbejder)alleIterator.next();
      if (medarb.getTilstand() == Medarbejder.TILSTAND_ANSAT)
        vectorAnsatte.add(medarb);
    }
    return vectorAnsatte.iterator();
  }
}