package projektsystemFunktioner;
import projektsystemKerne.*;
import java.util.*;
/**  
  * Funktionsklasse med ekstra Projekt-funktioner
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/  
public class ProjektFunktioner
{
  //-------------------------------------------------------------------
  //  Det kunne vre en god id at have en iterator, som kunne give
  //  alle aktiviteter med en bestemt tilstand.
  //  Det kunne have vre en god id at have en iterator mere, 
  //  som kunne give alle aktiviteter med en bestemt tilstand.
  //  En sdan vil dog med fordel kunne placeres i kernen p Projekt,
  //  hvor der kan optimeres en del f.eks med SQL i DB-lsningen.
  //-------------------------------------------------------------------
  public static Aktivitet firstAktiveAktivitet (Projekt projekt)
  {
    Iterator aktivitetIterator = projekt.getAktivitetIterator();
    Aktivitet aktivAktivitet = null;
    while (aktivitetIterator.hasNext() && aktivAktivitet == null)
    {
        Aktivitet aktivitet = (Aktivitet)aktivitetIterator.next();
        if (aktivitet.getTilstand() == Aktivitet.TILSTAND_AKTIV)
        	aktivAktivitet = aktivitet;
    }
    return aktivAktivitet;
  }
}