package projektsystemGUI;
import projektsystemFunktioner.*;
import projektsystemKerne.*;
import bjbupack.util.Convert;
import bjbupack.gui.SelectDialog;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.sql.*;  
import java.awt.Rectangle;
import java.awt.Dimension;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import java.awt.SystemColor;
/**  
  * GUI-Klassen til  Projektadministration
  * @version  Februar 2003 (1.15)
  * @author   ObjectGenerator  
*/  

public	class ProjektAdmPanel extends JPanel
{
  private Frame        ownerFrame;

  private Projekt	  projekt;

  private Button       knapSelect           = new Button     ();
  private Button       knapReplace          = new Button     ();
  private Button       knapFaerdigmeld      = new Button	();
  private Button       knapAdd	            = new Button     ();
  private Button       knapRemove           = new Button     ();
  private Button       knapAktiviteter	    = new Button	 ();
  private Button       knapOpretAktivitet   = new Button     ();
//  private Button	 knapReturn  = new Button     (); // Hvis Dialog

  private Label 	    labelBetegnelse        = new Label ();
  private TextField	  betegnelse	          = new TextField ();
  private Label 	    labelEtableringsDato  = new Label ();
  private TextField	  etableringsDato       = new TextField ();
  private Label 	    labelFaerdigDato      = new Label ();
  private TextField	  faerdigDato	          = new TextField ();
  private Label 	    labelTilstand	        = new Label ();
  private TextField	  tilstand	            = new TextField ();


  public ProjektAdmPanel (Frame ownerFrame)
  {
//    super(ownerFrame, true/*modal*/);  // Hvis dialog
    this.ownerFrame = ownerFrame;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  public void jbInit ()  throws Exception
  {
    this.setSize(new Dimension(676, 324));  // af hensyn til tegning med JDeveloper
//    this.setTitle("Projekt"); 	      // Hvis dialog
    Dimension dim = this.ownerFrame.getSize();
    this.setBounds(new Rectangle(3, 43, (int)dim.getWidth()-6, (int)dim.getHeight()-27)); // Med som strrelse i Panel
    this.setBorder(new EtchedBorder());// med p paneludgave for at adskille
    this.setLayout(null);
    this.setBackground(SystemColor.text);
  
    knapSelect.setLabel("Vlg projekt");
    knapSelect.setBounds(new Rectangle(500, 40, 140, 25));
    knapAdd.setLabel("Opret projekt");
    knapAdd.setBounds(new Rectangle(500, 70, 140, 25));
    knapReplace.setLabel("Ret stamdata");
    knapReplace.setBounds(new Rectangle(500, 100, 140, 25));
    knapFaerdigmeld.setLabel("Frdigmeld projekt");
    knapFaerdigmeld.setBounds(new Rectangle(500, 130, 140, 25));
    knapRemove.setLabel("Slet projekt");
    knapRemove.setBounds(new Rectangle(500, 160, 140, 25));
    knapAktiviteter.setLabel("Aktiviteter");
    knapAktiviteter.setBounds(new Rectangle(500, 200, 140, 25));
    knapOpretAktivitet.setLabel("Ny aktivitet");
    knapOpretAktivitet.setBounds(new Rectangle(500, 230, 140, 25));
//    knapReturn.setLabel("Retur");				// Hvis dialog
//    knapReturn.setBounds(new Rectangle(465, 270, 140, 25));	// Hvis dialog

    labelBetegnelse.setText("Betegnelse:");
    labelBetegnelse.setBounds(new Rectangle(50, 50, 70, 15));
    labelEtableringsDato.setText("Etableret dato :");
    labelEtableringsDato.setBounds(new Rectangle(50, 75, 100, 15));
    labelFaerdigDato.setText("Frdig dato:");
    labelFaerdigDato.setBounds(new Rectangle(50, 100, 75, 15));
    labelTilstand.setText("Tilstand:");
    labelTilstand.setBounds(new Rectangle(50, 125, 65, 15));
  
    betegnelse.setEnabled(false);
    betegnelse.setBounds(new Rectangle(205, 45, 250, 20));
    etableringsDato.setEnabled(false);
    etableringsDato.setBounds(new Rectangle(205, 70, 75, 20));
    faerdigDato.setEnabled(false);
    faerdigDato.setBounds(new Rectangle(205, 95, 75, 20));
    tilstand.setEnabled(false);
    tilstand.setBounds(new Rectangle(205, 120, 75, 20));

    this.add(knapSelect);
    this.add(knapReplace);
    this.add(knapFaerdigmeld);
    this.add(knapAdd);
    this.add(knapRemove);
    this.add(knapAktiviteter);
    this.add(knapOpretAktivitet);
    this.add(labelBetegnelse, null);
    this.add(betegnelse, null);
    this.add(labelEtableringsDato, null);
    this.add(etableringsDato, null);
    this.add(labelFaerdigDato, null);
    this.add(faerdigDato, null);
    this.add(labelTilstand, null);
    this.add(tilstand, null);
//    this.add(knapReturn);		      // Hvis dialog
  

//    this.addWindowListener ( new ProjektAdm_WindowClosing(this) );  // Hvis dialog
    knapSelect.addActionListener(new ProjektAdm_knapSelect_Action(this));
    knapReplace.addActionListener(new ProjektAdm_knapReplace_Action(this));
    knapFaerdigmeld.addActionListener(new ProjektAdm_knapFaerdigmeld_Action(this));
    knapAdd.addActionListener(new ProjektAdm_knapAdd_Action(this));
    knapRemove.addActionListener(new ProjektAdm_knapRemove_Action(this));
    knapAktiviteter.addActionListener(new ProjektAdm_knapAktiviteter_Action(this));
    knapOpretAktivitet.addActionListener(new ProjektAdm_knapOpretAktivitet_Action(this));
//    knapReturn.addActionListener(new ProjektAdm_knapReturn_Action(this));   // Hvis dialog

    projektToFrame ();
  }
  
  //=================================================================
  
  public void projektToFrame ()
  {
    if (projekt==null)
    {
      this.betegnelse.setText("");
      this.etableringsDato.setText("");
      this.faerdigDato.setText("");
      this.tilstand.setText("");
      knapReplace.setEnabled(false);
      knapRemove.setEnabled(false);
      knapFaerdigmeld.setEnabled(false);
      knapAktiviteter.setEnabled(false);
      knapOpretAktivitet.setEnabled(false);
    }
    else
    {
      this.betegnelse.setText(""+projekt.getBetegnelse());
      if ( projekt.getEtableringsDato() == null )
      	this.etableringsDato.setText("");
      else
        this.etableringsDato.setText(projekt.getEtableringsDato().toString().substring(0,19));
      if ( projekt.getFaerdigDato() == null )
      	this.faerdigDato.setText("");
      else
      	this.faerdigDato.setText(projekt.getFaerdigDato().toString().substring(0,19));
      if (projekt.getTilstand() == Projekt.TILSTAND_FAERDIG)   this.tilstand.setText("Frdig");
      else  this.tilstand.setText("Aktiv");
      knapReplace.setEnabled(true);
      knapAktiviteter.setEnabled(true);
      if (projekt.getTilstand() == Projekt.TILSTAND_AKTIV)
      {
      	knapFaerdigmeld.setEnabled(true);
      	knapRemove.setEnabled(false);
      	knapOpretAktivitet.setEnabled(true);
      }
      else if (projekt.getTilstand() == Projekt.TILSTAND_FAERDIG)
      {
      	knapFaerdigmeld.setEnabled(false);
      	knapRemove.setEnabled(true);
      	knapOpretAktivitet.setEnabled(false);
      }
    }
  }
  
  public void selectProjekt ()
  {
    Iterator  iterator = GlobalModel.getProjektsystem().getProjektIterator();
    SelectDialog  selectDialog = new SelectDialog(this.ownerFrame,"Projekter",true,iterator,15,true);
    selectDialog.setSize(600,400);
    selectDialog.setVisible(true);
    Object[]  ov  =  selectDialog.getSelectedObjects();
    if ((ov!=null)&&(ov.length>0))
      projekt = (Projekt)ov[0];
    projektToFrame ();
  }
  
  public void replaceProjekt ()
  {

    ProjektRetStamdataDialog  projektRetStamdataDialog = new ProjektRetStamdataDialog(this.ownerFrame, this.projekt);
    projektRetStamdataDialog.setVisible(true);

    projektToFrame ();
  }
  
  public void faerdigmeldProjekt ()
  {
      Aktivitet aktivAktivitet = ProjektFunktioner.firstAktiveAktivitet(this.projekt);
      if (aktivAktivitet == null)
      {
        ProjektFaerdigDialog  projektFaerdigDialog = new ProjektFaerdigDialog(this.ownerFrame, this.projekt);
        projektFaerdigDialog.setVisible(true);
        projektToFrame ();
      }
      else
      {
        AktivitetAdmDialog aktivitetAdmDialog = new AktivitetAdmDialog (this.ownerFrame, projekt, aktivAktivitet);
        aktivitetAdmDialog.setVisible(true);
      }
  }

  public void addProjekt ()
  {

    ProjektOpretDialog	projektOpretDialog = new ProjektOpretDialog(this.ownerFrame);
    projektOpretDialog.setVisible(true);
    projekt = projektOpretDialog.getProjekt();

    projektToFrame ();
  }
  
  public void removeProjekt ()
  {
    // IKKE IMPLEMENTERET
  }
  
  public void aktiviteter ()
  {
/*
    AktivitetAdmDialog aktivitetAdmDialog = new AktivitetAdmDialog (this.ownerFrame, projekt, null);
    aktivitetAdmDialog.setVisible(true);
*/

    Aktivitet aktivitet = null;
    do
    {
      Iterator	iterator = projekt.getAktivitetIterator();
      SelectDialog  selectDialog = new SelectDialog(this.ownerFrame,"Aktiviteter",true,iterator,15,true);
      selectDialog.setSize(600,400);
      selectDialog.setVisible(true);

      Object[]	ov  =  selectDialog.getSelectedObjects();
      if ((ov!=null)&&(ov.length>0))
      {
      	aktivitet = (Aktivitet)ov[0];
        // opstart detail-billede for aktivitet, overfr projekt og aktivitet
        AktivitetAdmDialog aktivitetAdmDialog = new AktivitetAdmDialog (this.ownerFrame, projekt, aktivitet);
        aktivitetAdmDialog.setVisible(true);
      }
      else
      	aktivitet = null;
	
    } while (aktivitet != null);

  }

  public void opretAktivitet ()
  {

      AktivitetOpretDialog  aktivitetOpretDialog = new AktivitetOpretDialog(this.ownerFrame, this.projekt);
      aktivitetOpretDialog.setVisible(true);

  }

/* Hvis dialog	
  public void closeWindow ()
  {
    this.dispose();
  }
*/
}

//=================================================================
/* Hvis Dialog
class ProjektAdm_WindowClosing extends WindowAdapter
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_WindowClosing(ProjektAdmPanel  adaptee)
  {  this.adaptee = adaptee; }
  public void windowClosing(WindowEvent e)
  { adaptee.closeWindow ();  }
}
*/
class ProjektAdm_knapSelect_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapSelect_Action(ProjektAdmPanel	adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.selectProjekt();  }
}

class ProjektAdm_knapReplace_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapReplace_Action(ProjektAdmPanel  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.replaceProjekt();	}
}

class ProjektAdm_knapFaerdigmeld_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapFaerdigmeld_Action(ProjektAdmPanel  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.faerdigmeldProjekt();  }
}

class ProjektAdm_knapAdd_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapAdd_Action(ProjektAdmPanel  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.addProjekt();  }
}

class ProjektAdm_knapRemove_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapRemove_Action(ProjektAdmPanel	adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.removeProjekt();  }
}

class ProjektAdm_knapAktiviteter_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapAktiviteter_Action(ProjektAdmPanel  adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.aktiviteter();  }
}

class ProjektAdm_knapOpretAktivitet_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapOpretAktivitet_Action(ProjektAdmPanel	adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.opretAktivitet();	}
}
/* Hvis Dialog
class ProjektAdm_knapReturn_Action implements java.awt.event.ActionListener
{
  ProjektAdmPanel   adaptee;
  ProjektAdm_knapReturn_Action(ProjektAdmPanel	adaptee)
  {  this.adaptee = adaptee; }
  public void actionPerformed(ActionEvent e)
  {  adaptee.closeWindow();  }
}
*/
