package projektsystemKerne;
import bjbupack.util.Convert;
import java.sql.*;  
/**
  * Dannelse af testdata til afprvning
  * @version  Februar 2003
  * @author   Bjrk Boye Busch
*/

public  class TestModelKerneSerialize
{
  public static void danTestModel ()
  {
    Postdistrikt post1 = GlobalModel.getProjektsystem().opretPostdistrikt(5000,"Odense C");
    Postdistrikt post2 = GlobalModel.getProjektsystem().opretPostdistrikt(5200,"Odense V");
    Postdistrikt post3 = GlobalModel.getProjektsystem().opretPostdistrikt(5210,"Odense NV");
    Medarbejder  medarb1 =
               GlobalModel.getProjektsystem().opretMedarbejder("Bjrk", "Boye",
                  "Sophus Bauditz vej 5","66111111",
                  Timestamp.valueOf("2002-01-15 00:00:00"),
                  post3);
    Medarbejder  medarb2 =
               GlobalModel.getProjektsystem().opretMedarbejder("Susanne", "Funch",
                  "Sophus Bauditz vej 5","66111111",
                  Timestamp.valueOf("2003-01-15 00:00:00"),
                  post3);

    Projekt proj1 = GlobalModel.getProjektsystem().opretProjekt("Afprvning",Timestamp.valueOf("2002-02-15 00:00:00"));
    Projekt proj2 = GlobalModel.getProjektsystem().opretProjekt("Test",Timestamp.valueOf("2002-02-13 00:00:00"));

    Aktivitet akt1 = proj1.opretAktivitet("test 1",Timestamp.valueOf("2002-02-16 00:00:00"),medarb1);
    Aktivitet akt2 = proj1.opretAktivitet("test 2",Timestamp.valueOf("2002-02-16 00:00:00"),medarb1);

  }
}
